/*
 *  Copyright (c) 2010-2013, Rutgers, The State University of New Jersey
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above copyright
 *        notice, this list of conditions and the following disclaimer in the
 *        documentation and/or other materials provided with the distribution.
 *      * Neither the name of the organization(s) stated above nor the
 *        names of its contributors may be used to endorse or promote products
 *        derived from this software without specific prior written permission.
 *  
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 *  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @file   mftimer.h
 * @author wontoniii (bronzino@winlab.rutgers.edu)
 * @date   October, 2013
 * @brief  Temp.
 *
 * Temp.
 */

#ifndef MF_TIMER_H_
#define MF_TIMER_H_

#include <semaphore.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>

#include "mftypes.h"
#include "mfeventqueue.h"
#include "mflog.h"

void *timerProc(void *);

class MF_Timer {
	struct timeval started;
	pthread_t mTid;
	int interface;
	bool running;
	bool trig;
	bool cont;
	int timeToSleepMicros;
	MF_EventQueue *eq;
	sem_t access;
	int nextMicros;
	u_int chnkID;

public:
	MF_Timer();
	MF_Timer(MF_EventQueue *, int, int	);
	~MF_Timer();
	void loop();
	void run();
	void reset(u_int);
	void stop();
	u_int getChunkID();
};

#endif /* MF_TIMER_H_ */
